// @ts-ignore
/* eslint-disable */
import { request } from 'umi'

/** 获取当前的用户 GET /backstage/currentUser */
export async function currentUser(options?: { [key: string]: any }) {
  return request<API.CurrentUser>('/login/currentUser', {
    method: 'GET',
    ...(options || {})
  })
}

/** 退出登录接口 POST /login/outLogin */
export async function outLogin(options?: { [key: string]: any }) {
  // return request<Record<string, any>>('/login/outLogin', {
  //   method: 'POST',
  //   ...(options || {})
  // })
}

/** 登录接口 POST /login */
export async function login(body: API.LoginParams, options?: { [key: string]: any }) {
  return request<API.LoginResult>('/login', {
    method: 'POST',
    data: body,
    ...(options || {})
  })
}

/** 获取菜单id列表 */
export async function queryMenuList() {
  return request<API.MenuListItem[]>('/menu/list')
}

/** 获取用户权限 */
export async function queryMenuRole() {
  return request<API.Roles>('/menu/role')
}

/** 获取菜单下的权限列表 */
export async function fetchPermRoleByMenuId(id: string) {
  return request('/permission/list', {
    params: { backstageMenuId: id }
  })
}

/** 获取单一菜单下的角色列表 */
export async function fetchRoleListByMenuId(id: string) {
  return request<API.MenuRoleItem[]>('/role/list', {
    params: { backstageMenuId: id }
  })
}

/** 新增单一菜单下角色 */
export async function createRoleWithMenuId(params: API.CreateRoleParams) {
  return request('/role/add', {
    method: 'POST',
    data: params
  })
}

/** 获取部门列表 */
export async function getDepartmenList() {
  return request<API.DepartmentItem[]>('/department/list')
}

/** 获取角色下员工列表 */
export async function fetchRoleStaffListByRoleId(params: { id: string }) {
  return request<API.RoleStaffListItem[]>('/role/staff', {
    params
  })
}

/** 角色下关联员工 */
export async function addRoleStaff(params: API.AddRoleStaffParams) {
  return request('/role/staff/add', {
    method: 'POST',
    data: params
  })
}

/** 角色下更新权限 */
export async function updateRolePermission(params: API.UpdateRolePermissionParams) {
  return request('/role/permission/save', {
    method: 'POST',
    data: params
  })
}

/** 角色下详情 */
export async function getRolePermissions(params: { id: string }) {
  return request<API.GetRolePermissionResultModel>('/role/detail', {
    params
  })
}

/** 获取员工列表 */
export async function fetchStaffList(params: API.GetStaffListParams) {
  return request<API.StaffItem[]>('/role/staff/all', {
    params
  })
}

/** 删除角色 */
export async function deleteRole({ id }: { id: string }) {
  return request('/role/delete', {
    method: 'POST',
    data: { id }
  })
}

/** 编辑角色 */
export async function updateStaff(params: API.UpdateStaff) {
  return request('/role/update', {
    method: 'POST',
    data: params
  })
}

/** 角色下移除员工 */
export async function deleteStaff(params: API.DeleteStaff) {
  return request('/role/staff/delete', {
    method: 'POST',
    data: params
  })
}

/** 角色下更新数据权限 */
export async function updatePermDataByRoleId(params: API.UpdatePermData) {
  return request('/role/permission/data/save', {
    method: 'POST',
    data: params
  })
}

/** 获得商机组列表 */
export async function getBusinessgroupList() {
  return request<API.BusinessgroupItem[]>('/BusinessGroup/list')
}

/** 新增商机状态组 */
export async function addBusinessgroup(params: API.AddBusinessgroupParam) {
  return request('/BusinessGroup/add', {
    method: 'POST',
    data: params
  })
}

/** 删除商机组 */
export async function delBusinessGroupById(id: string) {
  return request('/BusinessGroup/delete', {
    method: 'POST',
    data: { id }
  })
}

/** 启用/停用商机组 */
export async function changeBusinessGroupStatus(params: { id: string; activation: number }) {
  return request('/BusinessGroup/activation', {
    method: 'POST',
    data: params
  })
}

/** 更新商机组 */
export async function updateBusinessGroup(params: API.UpdateBusinessgroupParam) {
  return request('/BusinessGroup/update', {
    method: 'POST',
    data: params
  })
}
