import { request } from 'umi'

/** 获取角色id下员工列表 */
export async function queryRoleStaffList() {
  return request<API.RoleStaffListItem[]>('/role/staff')
}

/** 获取加班申请人列表 */
export async function fetchAttendanceList() {
  return request<API.AttendanceItem[]>('/attendance/list')
}

/** 删除关联加班人 */
export async function unlinkAttendance(params: API.UnlinkAttendance) {
  return request('/attendance/unlinkStaff', {
    method: 'POST',
    data: params
  })
}

/** 关联加班人 */
export async function linkAttendance(params: API.LinkAttendance) {
  return request('/attendance/linkStaff', {
    method: 'POST',
    data: params
  })
}

/** 新增申请人 */
export async function addAttendance(params: API.Addattendance) {
  return request('/attendance/add', {
    method: 'POST',
    data: params
  })
}

/** 删除申请人 */
export async function deleteAttendance(params: API.DeleteAttendance) {
  return request('/attendance/delete', {
    method: 'POST',
    data: params
  })
}

/** 获取销假参数 */
export async function fetchParametersDetail() {
  return request<API.ParametersDetail[]>('/parameters/detail')
}

/** 设置销假参数 */
export async function updateParameters(params: API.UpdateParameters) {
  return request('/parameters/update', {
    method: 'POST',
    data: params
  })
}
