// @ts-ignore
/* eslint-disable */

declare namespace API {
  type CurrentUser = {
    staff: {
      staffId: string
      categoryId: string
      departmentId: string
      departmentName: string
      username: string
      category: string
      avatar: string
      qq: string
      qualifications: string
      isAdmin: number
      roles: string[]
    }
    menus: MenuListItem[]
  }

  type LoginResult = {
    code: number
    msg: number
    data?: {
      token: string
    }
  }

  type PageParams = {
    current?: number
    pageSize?: number
  }

  type BasicFetchResult<T extends any> = {
    list: T[]
    total: number
  }

  type MenuListItem = {
    id: string
    parend_id: string
    name: string
    sort: number
  }

  type Roles = string[]

  type MenuRoleItem = {
    backstageMenuId: string
    id: string
    name: string
  }

  type CreateRoleParams = {
    name: string
    backstageMenuId: string
  }

  type LoginParams = {
    username?: string
    password?: string
    autoLogin?: boolean
    type?: string
  }

  type ErrorResponse = {
    /** 业务约定的错误码 */
    errorCode: string
    /** 业务上的错误信息 */
    errorMessage?: string
    /** 业务上的请求是否成功 */
    success?: boolean
  }

  type NoticeIconList = {
    data?: NoticeIconItem[]
    /** 列表的内容总数 */
    total?: number
    success?: boolean
  }

  type NoticeIconItemType = 'notification' | 'message' | 'event'

  type NoticeIconItem = {
    id?: string
    extra?: string
    key?: string
    read?: boolean
    avatar?: string
    title?: string
    status?: string
    datetime?: string
    description?: string
    type?: NoticeIconItemType
  }

  type RoleStaffListItem = {
    staffId: string
    categoryId: string
    departmentId: string
    positionId: string
    username: string
    category: string
    jobNumber: string
    qq: string
    phone: string
    departmentName: string
    position: string
    hiredate: string
  }

  type GetStaffListParams = {
    search?: string
    departmentId?: string
  } & PageParams

  type StaffItem = {
    id: string
    categoryId: string
    departmentId: string
    positionId: string
    username: string
    category: string
    avatar: string
    qq: string
    qualifications: string
    departmentName: string
    gender: string
    phone: string
    avtelephoneatar: string
    email: string
    birthday: string
    position: string
    jobNumber: string
    hiredate: string
    remittanceName: string
    bankName: string
    bankNumber: string
    coupletNumber: string
    salaryCard: string
    salaryBank: string
    baseWage: string
    postWage: string
    achievementBonus: string
    marriage: string
    nativePlace: string
    emergencyContacts: string
    living: string
    IDcards: string
    IDcardsImgA: string
    IDcardsImgB: string
    certificate: string
    diploma: string
    professionalTitle: string
    nation: string
    graduateInstitutions: string
    major: string
    education: string
    graduationTime: string
    registeredResidence: string
    householdRegistrationType: string
    IDcardsValidity: string
  }

  type AddRoleStaffCommonParams = {
    staffId: string
    id?: string
  }

  type UpdateRolePermissionParams = {
    id: string
    permission: string
  }

  type GetRolePermissionResultModel = {
    id: string
    backstageMenuId: string
    name: string
    permission: string | null
    dataPermission: string | null
  }

  type AttendanceItem = {
    id: string
    applicantStaffId: string
    applicantStaffName: string
    staff: { staffId: string; staffName: string }[]
  }

  type UnlinkAttendance = {
    id: string
    staffId: string
  }

  type LinkAttendance = {
    id: string
    staffId: string
  }

  type Addattendance = {
    applicantStaffId: string
  }

  type DeleteAttendance = {
    id: string
  }

  type UpdateStaff = {
    id: string
    name: string
  }

  type UpdatePermData = {
    id: string
    dataPermission: any[]
  }

  type BusinessgroupItem = {
    id: string
    name: string
    activation: number
    createName: string
    departmentName: string
    createTime: string
  }

  type AddBusinessgroupParam = {
    name: string
    departmentIds: string[]
    stageSettings: string
  }

  type UpdateBusinessgroupParam = AddBusinessgroupParam & { id: string }
  type DepartmentItem = {
    id: string
    key: string
    parentId: string
    title: string
    name: string
    create_time: string
    children: DepartmentItem[]
    isLeaf: boolean
  }

  type ParametersDetail = {
    parametersType: string
  }

  type UpdateParameters = {
    parametersType: string
    content: string
  }
}
