/* eslint no-useless-escape:0 import/prefer-default-export:0 */
const reg =
  /(((^https?:(?:\/\/)?)(?:[-;:&=\+\$,\w]+@)?[A-Za-z0-9.-]+(?::\d+)?|(?:www.|[-;:&=\+\$,\w]+@)[A-Za-z0-9.-]+)((?:\/[\+~%\/.\w-_]*)?\??(?:[-\+=&;%@.\w_]*)#?(?:[\w]*))?)$/

export const isUrl = (path: string): boolean => reg.test(path)

export const isAntDesignPro = (): boolean => {
  if (ANT_DESIGN_PRO_ONLY_DO_NOT_USE_IN_YOUR_PRODUCTION === 'site') {
    return true
  }
  return window.location.hostname === 'preview.pro.ant.design'
}

// 给官方演示站点用，用于关闭真实开发环境不需要使用的特性
export const isAntDesignProOrDev = (): boolean => {
  const { NODE_ENV } = process.env
  if (NODE_ENV === 'development') {
    return true
  }
  return isAntDesignPro()
}

export const formatPermission = (type: 'init' | 'submit', values: any) => {
  if (type === 'init') {
    const newValues = { ...JSON.parse(values) }
    // eslint-disable-next-line no-restricted-syntax
    for (const key in newValues) {
      if (Object.prototype.hasOwnProperty.call(newValues, key)) {
        if (newValues[key]?.length) {
          newValues[`show${key.replace(key[0], key[0].toUpperCase())}`] = true
        }
      }
    }
    return newValues
  }
  const newValues = { ...values }
  // eslint-disable-next-line no-restricted-syntax
  for (const key in newValues) {
    if (Object.prototype.hasOwnProperty.call(values, key)) {
      if (key.indexOf('show') !== -1) {
        delete newValues[key]
      }
    }
  }
  return newValues
}
